searchNodes=[{"doc":"Integrated DNN interpreter for Elixir. Deep Learning inference framework.","ref":"NNInterp.html","title":"NNInterp","type":"module"},{"doc":"Adjust NMS result to aspect of the input image. (letterbox) Parameters: nms_result - NMS result {:ok, result} [rx, ry] - aspect ratio of the input image","ref":"NNInterp.html#adjust2letterbox/2","title":"NNInterp.adjust2letterbox/2","type":"function"},{"doc":"Get name of backend NN framework.","ref":"NNInterp.html#framework/0","title":"NNInterp.framework/0","type":"function"},{"doc":"Ensure that the back-end framework is as expected.","ref":"NNInterp.html#framework?/1","title":"NNInterp.framework?/1","type":"function"},{"doc":"Get the flat binary from the output tensor on the interpreter. Parameters mod - modules' names or session. index - index of output tensor in the model","ref":"NNInterp.html#get_output_tensor/3","title":"NNInterp.get_output_tensor/3","type":"function"},{"doc":"Get list of the flat binary from the output tensoron the interpreter. Parameters mod - modules' names or session. range - range of output tensor in the model","ref":"NNInterp.html#get_output_tensors/2","title":"NNInterp.get_output_tensors/2","type":"function"},{"doc":"Get the propaty of the model. Parameters mod - modules' names","ref":"NNInterp.html#info/1","title":"NNInterp.info/1","type":"function"},{"doc":"Invoke prediction. Two modes are toggled depending on the type of input data. One is the stateful mode, in which input/output data are stored as model states. The other mode is stateless, where input/output data is stored in a session structure assigned to the application. Parameters mod/session - modules name(stateful) or session structure(stateless). Examples. output_bin = session ( ) # stateless mode |&gt; NNInterp . set_input_tensor ( 0 , input_bin ) |&gt; NNInterp . invoke ( ) |&gt; NNInterp . get_output_tensor ( 0 )","ref":"NNInterp.html#invoke/1","title":"NNInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms. Parameters mod - modules' names num_boxes - number of candidate boxes num_class - number of category class boxes - binaries, serialized boxes tensor[ num_boxes ][4]; dtype: float32 scores - binaries, serialized score tensor[ num_boxes ][ num_class ]; dtype: float32 opts iou_threshold: - IOU threshold score_threshold: - score cutoff threshold sigma: - soft IOU parameter boxrepr: - type of box representation :center - center pos and width/height :topleft - top-left pos and width/height :corner - top-left and bottom-right corner pos","ref":"NNInterp.html#non_max_suppression_multi_class/5","title":"NNInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"","ref":"NNInterp.html#run/1","title":"NNInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter. Parameters mod - modules' names or session. index - index of input tensor in the model bin - input data - flat binary, cf. serialized tensor opts - data conversion","ref":"NNInterp.html#set_input_tensor/4","title":"NNInterp.set_input_tensor/4","type":"function"},{"doc":"Put flat binaries to the input tensors on the interpreter. Parameters mod - modules' names or session. from - first index of input tensor in the model items - list of input data - flat binary, cf. serialized tensor","ref":"NNInterp.html#set_input_tensors/3","title":"NNInterp.set_input_tensors/3","type":"function"},{"doc":"Stop the interpreter. Parameters mod - modules' names","ref":"NNInterp.html#stop/1","title":"NNInterp.stop/1","type":"function"},{"doc":"Ensure that the model matches the back-end framework. Parameters model - path of model file url - download site","ref":"NNInterp.html#validate_model/2","title":"NNInterp.validate_model/2","type":"function"},{"doc":"","ref":"NNInterp.URL.html","title":"NNInterp.URL","type":"module"},{"doc":"Download and process data from url. Parameters url - download site url func - function to process downloaded data","ref":"NNInterp.URL.html#download/2","title":"NNInterp.URL.download/2","type":"function"},{"doc":"Download and save the file from url. Parameters url - download site url path - distination path of downloaded file name - name for the downloaded file","ref":"NNInterp.URL.html#download/3","title":"NNInterp.URL.download/3","type":"function"},{"doc":"","ref":"NNInterp.URL.html#get!/1","title":"NNInterp.URL.get!/1","type":"function"},{"doc":"NNInterp is an integrated DNN interpreter for Elixir. It is the successor to TflInterp and OnnxInterp, and allows you to choose a backend framework from &quot;tflite&quot;, &quot;onnx-runtime&quot; and &quot;libtorch&quot;.","ref":"readme.html","title":"NNInterp","type":"extras"},{"doc":"I have confirmed it works in the following OS environment. Windows 10 with Visual C++ 2019 WSL2/Ubuntu 20.04","ref":"readme.html#platform","title":"NNInterp - Platform","type":"extras"},{"doc":"cmake 3.13 or later is required. Visual C++ 2019 for Windows.","ref":"readme.html#requirements","title":"NNInterp - Requirements","type":"extras"},{"doc":"Add the following line to the list of dependencies in mix.exs . def deps do [ { :nn_interp , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"NNInterp - Installation","type":"extras"},{"doc":"First, select the back-end DNN framework. Set the environment variable NNINTERP to one of the following strings. tflite-cpu onnx-cpu libtorch-cpu As a little trick, you can put the NNINTERP settings in mix.exs as shown below. def deps do System . put_env ( &quot;NNINTERP&quot; , &quot;onnx-cpu&quot; ) [ ... ] end Next, obtain the trained PyTorch model and save it in a directory accessible by your application. The &quot;your-app/priv&quot; directory could be a suitable choice. $ cp your-trained-model.onnx ./priv Create a module that interfaces with the deep learning model. This module will require pre-processing and post-processing functionality, in addition to the inference processing provided by NNInterp, as demonstrated in the following example. At the beginning of your module, include the statement use NNInterp and specify the model path as an optional argument. In the inference section, you will need to set the data input for the model using NNInterp.set_input_tensor/3 , execute the inference with NNInterp.invoke/1 , and retrieve the inference results via NNInterp.get_output_tensor/2 . defmodule YourApp.YourModel do use NNInterp, model: &quot;priv/your-trained-model.onnx&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for models is a serialized 32-bit float tensor. output_bin = session() |&gt; NNInterp.set_input_tensor(0, input_bin) |&gt; NNInterp.invoke() |&gt; NNInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end","ref":"readme.html#basic-usage","title":"NNInterp - Basic Usage","type":"extras"},{"doc":"A demo of ResNet18 running on &quot;tflite&quot;, &quot;onnx-runtime&quot;, or &quot;libtorch&quot; is available on the GitHub for this project. Please refer: https://github.com/shoz-f/nn-interp Let's enjoy ;-)","ref":"readme.html#demo","title":"NNInterp - Demo","type":"extras"},{"doc":"NNInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"NNInterp - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Major Features and Improvements fixed the torchscript backend to handle input tensor data types correctly.","ref":"changelog.html#release-0-1-1","title":"Changelog - Release 0.1.1","type":"extras"},{"doc":"Experimental release.","ref":"changelog.html#release-0-1-0-may-25-2023","title":"Changelog - Release 0.1.0(May 25 2023)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP System . shell ( &quot;chcp 65001&quot; ) Mix . install ( [ { :nn_interp , &quot;~&gt; 0.1.0&quot; } , { :cimg , &quot;~&gt; 0.1.20&quot; } , { :nx , &quot;~&gt; 0.2.1&quot; } , { :kino , &quot;~&gt; 0.6.2&quot; } ] , system_env : [ { &quot;NNINTERP&quot; , &quot;libtorch&quot; } ] )","ref":"resnet18.html","title":"ResNet18 image classification - libtorch","type":"extras"},{"doc":"torchvision.models.resnet18 - pre-trained model included in Pytorch. https://pytorch.org/vision/main/models/generated/torchvision.models.resnet18.html Thanks a lot!!! convert the model to TorchScript with torch.jit.script(). import torch import torch.nn.functional as F import torchvision.models as models from torchvision.models import ResNet18_Weights r18 = models.resnet18(weights=ResNet18_Weights.IMAGENET1K_V1) r18_scripted = torch.jit.script(r18) dummy_input = torch.rand(1, 3, 224, 224) unscripted_output = r18(dummy_input) scripted_output = r18_scripted(dummy_input) unscripted_top5 = F.softmax(unscripted_output, dim=1).topk(5).indices scripted_top5 = F.softmax(scripted_output, dim=1).topk(5).indices print('Python model top5 results:\\n {}'.format(unscripted_top5)) print('TorchScript model top 5 results:\\n {}'.format(scripted_top5)) r18_scripted.save('r18_scripted.pt')","ref":"resnet18.html#0-original-work","title":"ResNet18 image classification - libtorch - 0.Original work","type":"extras"},{"doc":"","ref":"resnet18.html#implementation-with-nninterp-in-elixir","title":"ResNet18 image classification - libtorch - Implementation with NNInterp in Elixir","type":"extras"},{"doc":"Model&lt;br&gt; r18_scripted.pt: get from &quot; https://github.com/shoz-f/nn-interp/releases/download/0.1.0/r18_scripted.pt&quot; if not existed. Pre-processing&lt;br&gt; Resize the input image to the size {@width, @height} and gaussian normalize. Post-processing&lt;br&gt; Sort outputs and take first item. defmodule ResNet18 do @width 224 @height 224 use NNInterp , model : &quot;./model/resnet18.pt&quot; , url : &quot;https://github.com/shoz-f/nn-interp/releases/download/0.1.0/resnet18.pt&quot; , inputs : [ f32 : { 1 , 3 , @height , @width } ] , outputs : [ f32 : { 1 , 1000 } ] @imagenet1000 ( for item &lt;- File . stream! ( &quot;./imagenet1000.label&quot; ) do String . trim_trailing ( item ) end ) |&gt; Enum . with_index ( &amp; { &amp;2 , &amp;1 } ) |&gt; Enum . into ( %{ } ) def apply ( img , top \\\\ 1 ) do # preprocess bin = CImg . builder ( img ) |&gt; CImg . resize ( { @width , @height } ) |&gt; CImg . to_binary ( [ { :gauss , { { 123.7 , 58.4 } , { 116.3 , 57.1 } , { 103.5 , 57.4 } } } , :nchw ] ) # prediction outputs = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , bin ) |&gt; NNInterp . invoke ( ) |&gt; NNInterp . get_output_tensor ( 0 ) |&gt; Nx . from_binary ( { :f , 32 } ) |&gt; Nx . reshape ( { 1000 } ) # postprocess exp = Nx . exp ( outputs ) # softmax Nx . divide ( exp , Nx . sum ( exp ) ) |&gt; Nx . argsort ( direction : :desc ) |&gt; Nx . slice ( [ 0 ] , [ top ] ) |&gt; Nx . to_flat_list ( ) |&gt; Enum . map ( &amp; @imagenet1000 [ &amp;1 ] ) end end Launch ResNet18 . ResNet18 . start_link ( [ ] ) Display the properties of the ResNet18 model. NNInterp . info ( ResNet18 )","ref":"resnet18.html#1-defining-the-inference-module-resnet18","title":"ResNet18 image classification - libtorch - 1.Defining the inference module: ResNet18","type":"extras"},{"doc":"Load a photo and apply ResNet18 to it. unless File . exists? ( &quot;lion.jpg&quot; ) , do : NNInterp.URL . download ( &quot;https://github.com/shoz-f/nn-interp/releases/download/0.1.0/lion.jpg&quot; ) img = CImg . load ( &quot;lion.jpg&quot; ) Kino . render ( CImg . display_kino ( img , :jpeg ) ) ResNet18 . apply ( img , 3 )","ref":"resnet18.html#3-let-s-try-it","title":"ResNet18 image classification - libtorch - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"resnet18.html#4-til","title":"ResNet18 image classification - libtorch - 4.TIL ;-)","type":"extras"}]